<?php

$messages = array(
    'isEmpty' => 'This required field is empty. You need to specify a value.',
    'stringLengthTooShort' => "'%value%' is less than %min% characters.",
    'stringLengthTooLong' => "'%value%' is greater than %max% characters.",
    'regexNotMatch' => "'%value%' does not match the pattern '%pattern%'.",
    'notAlnum' => "'%value%' has non-alphanumeric characters. Make sure you are using only alphanumeric characters.",
    'stringEmpty' => "'%value%' is empty.",
    'loginSyntax' => 'You can use alphanumeric, dash, dot and underscore symbols in the username. The username should start with an alphabetic symbol or a number.',
    'loginExists' => 'User account %value% already exists.',
    'loginPassword' => 'The password should not contain the username.',
    'passwordSyntax' => 'Do not use quotes, space and national alphabet characters in the password.',
    'passwordLength' => 'The password should be between 5 and 20 characters in length.',
    'domain_invalid_name' => 'The specified domain name is not valid. You need to specify a valid domain name like domain.com.',
    'domain_already_exists' => 'This domain name already exists.',
    'dns_record_already_exists' => 'This DNS record already exists.',
    'domain_like_hostname' => 'This domain name is the same as hostname of the server.',
    'passwordsNotMatch' => 'The passwords you entered do not match each other.',
    'stringsNotEqual' => 'The values are not equal.',
    'equalMailAliases' => 'The specified e-mail alias is the same as another e-mail alias.',
    'mailAliasExist' => 'The specified e-mail alias already exists.',
    'mailNameExist' => 'The specified e-mail address already exists.',
    'mailListExist' => 'The specified address is already assigned to a mailing list.',
    'sysUserExist' => 'The specified username is already used by another system user. Please specify another username.',
    'emailAddressInvalid' => 'The specified e-mail address is not valid. You need to specify a valid e-mail address like user@domain.com.',
    'dir_invalid_name' => 'Invalid destination directory.',
    'directoryHidesDomain' => 'This directory cannot be used because it would overlap website located at %path%. Such overlapping would make the website unavailable.',
    'directoryHidesAnotherApplication' => 'This directory cannot be used because it would overlap another app installed at %path%. Such overlapping would make the installed app unavailable.',

    'directoryIsBehindAnotherApplication' => 'This directory cannot be used because it would be overlapped by another app installed at %path%. Such overlapping would make the app unavailable.',
    'databaseUserAlreadyExists' => 'The specified database user already exists.',
    'databaseAlreadyExists' => 'The specified database already exists.',
    'domainLoginSyntaxWindows' => 'You can use lowercase alphanumeric, dash, dot and underscore symbols in the username. The username should start with an alphabetic symbol and should be between 1 and 15 characters in length.',
    'domainLoginSyntaxUnix' => 'You can use lowercase alphanumeric, dash, and underscore symbols in the username. The username should start with a lowercase alphabetic character and should be between 1 and 16 characters in length.',
    'passwordsNotEqual' => 'The passwords you entered do not match each other.',
    'passwordPolicy' => '%policyError%',
    'fileImageSizeWidthTooBig' => "The image '%value%' you are trying to upload is too wide ('%width%'). Uploaded images cannot be wider than '%maxwidth%'.",
    'fileImageSizeWidthTooSmall' => "The image '%value%' you are trying to upload is not wide enough ('%width%'). Uploaded images should be at least '%minwidth%' wide.",
    'fileImageSizeHeightTooBig' => "The height of image '%value%' you are trying to upload is too big ('%height%'). Uploaded images cannot exceed '%maxheight%' in height.",
    'fileImageSizeHeightTooSmall' => "The height of image '%value%' you are trying to upload is too small ('%height%'). Uploaded images cannot be less than '%minheight%' in height.",
    'fileImageSizeNotDetected' => "The size of image '%value%' you are trying to upload could not be detected.",
    'fileImageSizeNotReadable' => "The image '%value%' you are trying to upload cannot be read.",
    'domainSslUnavailable' => 'The IP address associated with this website is already used by another website for establishing SSL protection.',
    'subdomainSslUnavailable' => 'SSL usage on subdomains is not supported.',
    'passwordConfirmation' => 'Confirm password',
    'invalidAdminLogin' => 'Unable to use the selected user\'s credentials for administrator\'s access. The specified username is not valid: %%cause%%',
    'invalidAdminPassword' => 'Unable to use the selected user\'s credentials for administrator\'s access. The specified password is not valid: %%cause%%',
    'passwordLengthTooShort' => "the password is shorter than %min% characters.",
    'passwordLengthTooLong' => "the password is longer than %max% characters.",
    'passwordRegexNotMatch' => "the password does not match the pattern '%pattern%'.",
    'emailAlreadyAssigned' => "The e-mail address %email% already belongs to another user (%user%).",
    'emailAlreadyAssignedNoDetails' => "The e-mail address %email% already belongs to another user.",
    'fileSharingEmptyFolderName' => "You need to specify a folder name.",
    'fileSharingInvalidFolderName' => "The specified folder name is not valid. It cannot contain any of the following characters: \\ / : * ? \" < > |",
    'fileSharingFolderExists' => "Cannot create a folder with the specified name because a folder with such name already exists.",
    'invalidUrl' => 'The specified address is not valid. You need to specify a valid address like http://domain.com.',
    'domainVirtualdirectoryReservedName' => 'This directory name is reserved. Please specify another name for your virtual directory.',
    'domainVirtualdirectoryInvalidName' => 'A directory name should contain only alphanumeric, underscore, and dash characters.',
    'filesharingPathUnavailable' => 'A directory with such name already exists under the specified domain. Please use another directory name.',
    'filesharingSslNotAvailableOnDomain' => 'You selected to use secure links but the domain has no SSL enabled. Please either select a domain with SSL support or clear the Generate secure links check box.',
    'filesharingSslNotAvailableOnDefaultDomain' => 'You selected to use secure links on IP address or host name of the server, but such links can be created only on websites with SSL support. Please either set up a website with SSL support or clear the Generate secure links check box.',
    'filesharingDefaultDomainSelectedOnServerIp' => 'You selected the server IP address to which a default domain is assigned. Please select a website as a root URL instead of the IP address.',
    'physicalPathOnDomainAlreadyExists' => 'A directory with such name already exists.',
    'virtualPathOnDomainAlreadyExists' => 'A virtual directory with such name already exists.',

    'docrootNotInWebspaceRoot' => 'The specified directory is not located within the webspace.',
    'docrootContainsSpecialCharacters' => 'The specified directory name contains symbols that cannot be used.',
    'docrootWithinProhibitedDirectory' => 'The specified directory contains a service directory.',
    'docrootWithinInstalledApplication' => 'The specified directory is overlapped by a web application installed at %path%.',
    'docrootTooLongPart' => 'The specified directory name is too long.',

    'subdomainWrongName' => '%errorDescription%',
    'subdomainWrongDomain' => 'Wrong domain was selected.',
    'phoneRegexNotMatch' => 'Incorrect phone number was specified, it contained not allowed symbols.',
    'stateInvalid' => 'Incorrect state or province was specified.',
    'zipRegexNotMatch' => 'Incorrect postal or ZIP code was specified.',

    'limitValueInvalid' => 'Incorrect limit value was specified.',
    'limitDiskspaceValueInvalid' => 'Disk space limit must be between 0 and 4095 TB.',
    'limitTrafficValueInvalid' => 'Traffic limit must be between 0 and 4095 TB/month.',
    'limitMboxQuotaValueInvalid' => 'Mailbox size limit must be between 0 and 4095 TB.',
    'limitValueOverused' => 'The currently used amount of resources exceeds the specified limit value. You cannot use a value less than %%used%%',
    'limitValueOverselled' => 'The resource usage limit of %%reserved%% is already assigned to subscriptions. You cannot specify a value less than %%reserved%%',

    'lessThan' => "'%value%' is less than '%min%'",
    'greaterThan' => "'%value%' is greater than '%max%'",

    'maillistReservedNameAlreadyExists' => 'The specified address is already reserved.',
    'maillistAlreadyExists' => 'The specified address is already used by a mailing list.',
    'maillistAlreadyExistsOnServer' => 'The specified name of mailing list is already used by other subscription',
    'mailnameAlreadyExists' => 'The specified e-mail address already exists.',
    'mailaliasAlreadyExists' => 'The specified address is already used by an e-mail alias.',

    'mailPostboxLimit' => '%message%',

    'userEmailLimitExceeded' => '%limitManagerMessage%',

    'passwordStrength' => 'This password is not strong enough according to the server security policy. Improve the password strength by using numbers, upper and lower-case characters, and special characters like !,@,#,$ and so on.',

    'emailCantBeRenamed' => "The server does not support renaming mail accounts.",
    'maillistAdminEmailShouldExistsOnDomain' => 'E-mail address of mailing list administrator should be registered on the same domain as the mailing list.',

    'webmailExists' => "Webmail service '%value%' already exists.",

    'invalidDbName' => 'Database name contains not allowed characters.',
    'longDbName' => 'Database name is too long.',
    'dbConnectFailed' => 'Unable to connect to database server. Check access restrictions and login/password.',

    'wrongUrlSyntax' => 'Specified address is not valid. You need to specify a valid address like http://domain.com, relative/path or mailto:address',

    'connectionRefused' => 'Connection refused.',
    'loginIncorrect' => 'Login incorrect',
    'failedToChangeDirectory' => 'Directory not exists',
    'failedToChangeMode' => 'Failed to change mode',
    'failedToCreateDirectory' => 'File creation not allowed',
    'failedToRenameDirectory' => 'File renaming not allowed',
    'failedToDeleteDirectory' => 'File deletion not allowed',

);
