<?php
echo $VAR->includeTemplate('server/nameVirtualHost.php', array(
    'ssl' => false,
));

echo $VAR->includeTemplate('server/nameVirtualHost.php', array(
    'ssl' => true,
));
?>

ServerName "<?php echo $VAR->server->fullHostName ?>"
<?php if ($VAR->server->admin->email): ?>
ServerAdmin "<?php echo $VAR->server->admin->email ?>"
<?php endif; ?>

DocumentRoot "<?php echo $VAR->server->webserver->httpDir ?>"

<IfModule mod_logio.c>
    LogFormat "<?php echo $VAR->server->webserver->apache->pipelogEnabled ? '%v@@%p@@' : ''?>%h %l %u %t \"%r\" %>s %O \"%{Referer}i\" \"%{User-Agent}i\"" plesklog
</IfModule>
<IfModule !mod_logio.c>
    LogFormat "<?php echo $VAR->server->webserver->apache->pipelogEnabled ? '%v@@%p@@' : ''?>%h %l %u %t \"%r\" %>s %b \"%{Referer}i\" \"%{User-Agent}i\"" plesklog
</IfModule>
<?php if ($VAR->server->webserver->apache->pipelogEnabled): ?>
CustomLog  "|<?php echo $VAR->server->productRootDir ?>/admin/sbin/pipelog <?php echo $VAR->server->webserver->httpsPort ?>" plesklog
<?php endif; ?>

<?php echo $VAR->includeTemplate('server/PCI_compliance.php') ?>

<Directory "<?php echo $VAR->server->webserver->vhostsDir ?>">
    AllowOverride "<?php echo $VAR->server->webserver->apache->allowOverrideDefault ?>"
    Options SymLinksIfOwnerMatch
    Order allow,deny
    Allow from all

<?php echo $VAR->includeTemplate('service/php.php', array(
    'enabled' => false,
)) ?>

</Directory>

<Directory "<?php echo $VAR->server->mailman->rootDir ?>">
    AllowOverride All
    Options SymLinksIfOwnerMatch
    Order allow,deny
    Allow from all
    <IfModule <?php echo $VAR->server->webserver->apache->php4ModuleName ?>>
        php_admin_flag engine off
    </IfModule>
    <IfModule mod_php5.c>
        php_admin_flag engine off
    </IfModule>
</Directory>

<IfModule mod_userdir.c>
    UserDir disabled
</IfModule>

<?php echo $VAR->includeTemplate('server/tomcat.php') ?>

Include <?php echo $VAR->domainsIpDefaultBootstrap ?>
<?php if (!file_exists($VAR->domainsIpDefaultBootstrap)) {
    $writer = new Template_Writer_Apache($VAR->domainsIpDefaultBootstrap);
    $writer->write(Template_Bootstrap_Apache::WARNING_MESSAGE);
}?>

Include <?php echo $VAR->domainsBootstrap ?>
<?php if (!file_exists($VAR->domainsBootstrap)) {
    $writer = new Template_Writer_Apache($VAR->domainsBootstrap);
    $writer->write(Template_Bootstrap_Apache::WARNING_MESSAGE);
}?>

<?php echo $VAR->includeTemplate('server/mailman.php', array(
    'ssl' => false,
    'ipLimit' => $VAR->server->webserver->apache->vhostIpCapacity,
)) ?>
<?php echo $VAR->includeTemplate('server/mailman.php', array(
    'ssl' => true,
    'ipLimit' => $VAR->server->webserver->apache->vhostIpCapacity,
)) ?>

<?php echo $VAR->includeTemplate('server/vhosts.php', array(
    'ssl' => false,
    'ipLimit' => $VAR->server->webserver->apache->vhostIpCapacity,
)) ?>
<?php echo $VAR->includeTemplate('server/vhosts.php', array(
    'ssl' => true,
    'ipLimit' => 1,
)) ?>
