<?php
include_once('spaw2plesk.php');

$dom_id = $session->getParam('dom_id');
if ($dom_id <= 0)
	psaerror('Domain ID is undefined.');

global $domain;
$domain = objectMaker('Domain', $dom_id);
if ($domain->error())
	psaerror('Unable to create Domain object: ' . $domain->getErrorMsg());

// [AUTOLOAD] include_once('class.FileManager.php');
$result = FileManager::detectInitialValuesByDomainId($domain->getId());
if (!$result)
	psaerror('Domain ID doesn\'t exist.');

$header = ($header = get_gpc('header')) ? base64_decode($header) : '';
$footer = ($footer = get_gpc('footer')) ? base64_decode($footer) : '';
$file_name = get_gpc('file_name');
$body = get_gpc('spaw2');

$fileManager = new FileManager($result['sys_user'], $result['basedir'], $result['webname'], $result['label']);
if (!$body)
	psaerror('Unable to fetch the data from submit.');

$code = $header . spaw2plesk_export_file_contents($body) . $footer;

if (!($current_codepage = $session->getParam(SPN_FILEMANAGER_CODEPAGE)))
	$current_codepage = PLESK_CODEPAGE;

if (!($new_codepage = get_gpc('codepage')))
	$new_codepage = $current_codepage;

if (false === ($file_code = plesk_iconv(PLESK_CODEPAGE, $new_codepage, $code))) {
	$new_codepage = PLESK_CODEPAGE;
	$file_code = $code;
}
$file_code = set_codepage_html($file_code, $new_codepage);

$session->putParam(SPN_FILEMANAGER_CODEPAGE, $new_codepage);

$filename = $fileManager->get_file_path($file_name);

$fileManager->fputs_wrapper($filename, $file_code);

go_to_uplevel();
?>