import os
import sys
import plesk_config

mswindows = (sys.platform == "win32")

def mkdirs(name, mode = 0777, owner = -1, group = -1):
    head, tail = os.path.split(name)
    if not tail:
        head, tail = os.path.split(head)
    if head and tail and not os.path.exists(head):
        mkdirs(head, mode, owner, group)
    
    os.mkdir(name, mode)
    if not mswindows:
        os.chown(name, owner, group)
        os.chmod(name, mode)

def createNewDirByAbsoluteAsciiPath(dir, mode = 0750, owner = 0, group = plesk_config.psaadm_gid()):
    if not os.path.isabs(dir):
        raise OSError("path must be absolute: " + dir + "\n")
    if os.path.exists(dir):
        raise OSError("Path " + dir + " exists.\n")

    try:
        mkdirs(dir, mode, owner, group)
    except UnicodeError:
        raise OSError("Invalid character in session directory name\n")

# Local Variables:
# mode: python
# indent-tabs-mode: nil
# tab-width: 4
# End:
