Jsw.namespace('Smb.Views');

Smb.Views.Migration = {

	updateDataToMigrate: function() {
    	Smb.Views.Migration.updateSendButton();
    	Smb.Views.Migration.updateMigrationContent();
    },
    
    updateSendButton: function() {
    	sendButton = $('btn-send').firstDescendant();
    	if (sendButton) {
    		migrateSelectedDomains = $('mirationSettings-dataToMigrate-selectedDomains').checked;
    		if (migrateSelectedDomains) {
    			sendButton.update(Smb.Views.Migration._locale.next);
    		} else {
    			sendButton.update(Smb.Views.Migration._locale.start);
    		}
    	}
    },
    
    updateMigrationContent: function() {
    	migrateSelectedDomains = $('mirationSettings-dataToMigrate-selectedDomains').checked;
    	
    	if (migrateSelectedDomains) {   	
    		$('mirationSettings-contentToMigrate-form-row').show();
    	} else {
    		$('mirationSettings-contentToMigrate-form-row').hide();
    	}
    	   	
    	Smb.Views.Migration.updateMigrationAccountSettings();
    },
    
    isAccountOptionsEnabled: function() {
    	migrateAllDomains = $('mirationSettings-dataToMigrate-allDomains').checked;
    	allContent = $('mirationSettings-contentToMigrate-allContent').checked;
    	mailOnly = $('mirationSettings-contentToMigrate-mailOnly').checked;

    	return migrateAllDomains ||
    		(!migrateAllDomains && allContent) ||
    		(!migrateAllDomains && mailOnly);    	
    },
    
    updateMigrationAccountSettings: function() {    	
    	elements = [$('mirationSettings-importAntiSpamSettings'), 
    	    $('mirationSettings-createUserAccounts')];
    	elements.each(Smb.Views.Migration.isAccountOptionsEnabled()? Form.Element.enable: Form.Element.disable);
    	Smb.Views.Migration.updateMigrationAccountRoleSettings();
    },
    
    updateMigrationAccountRoleSettings: function() {
    	enabled = Smb.Views.Migration.isAccountOptionsEnabled() && $('mirationSettings-createUserAccounts').checked 
    	if (enabled) {
    		$('mirationSettings-role').enable();
    	} else {
    		$('mirationSettings-role').disable();
    	}
    },
    
    initMigrationSettingsDialog: function(locale) {
    	Smb.Views.Migration._locale = locale;
    }
}

Jsw.onReady(function() {
    $('mirationSettings-dataToMigrate-allDomains').observe('click', Smb.Views.Migration.updateDataToMigrate);
    $('mirationSettings-dataToMigrate-selectedDomains').observe('click', Smb.Views.Migration.updateDataToMigrate);
    
    $('mirationSettings-contentToMigrate-allContent').observe('click', Smb.Views.Migration.updateMigrationAccountSettings);
    $('mirationSettings-contentToMigrate-mailOnly').observe('click', Smb.Views.Migration.updateMigrationAccountSettings);
    $('mirationSettings-contentToMigrate-withoutMail').observe('click', Smb.Views.Migration.updateMigrationAccountSettings);
    
    $('mirationSettings-createUserAccounts').observe('click', Smb.Views.Migration.updateMigrationAccountRoleSettings);
});
