Jsw.namespace('Smb.Views.Apps');

Smb.Views.Apps = {

    resizeBlocks: function() {
        var bodyHeight = document.body.clientHeight;

        if (Prototype.Browser.IE) {
            bodyHeight = document.documentElement.clientHeight;
        }

        var blockHeight = Element.getHeight($('objects-list'));
        var blockTop = Position.cumulativeOffset($('objects-list'))[1];

        var blockBottom = Element.getHeight($('footer-wrapper'));
        // correction for integrated mode
        if (self != top) {
            blockBottom = 20; // little border
        }

        var newBlockHeight = bodyHeight - blockTop - blockBottom;

        if (newBlockHeight < 200) {
            // minimum height
            newBlockHeight = 200;
        }

        $('objects-list-content-area').style.height = newBlockHeight - 3 + 'px';

        var catalogActionsBox = $('catalog-actions-box');

        if (catalogActionsBox) {
            var objectsContent = catalogActionsBox.next();

            if (catalogActionsBox.visible()) {
                objectsContent.setStyle({ 'height': newBlockHeight - catalogActionsBox.getHeight() - 3 + 'px' });
            } else {
                objectsContent.setStyle({ 'height': newBlockHeight - 3 + 'px' });
            }
        } else {
            $('objects-details-content').setStyle({ 'height': newBlockHeight - 3 + 'px' });
        }

        Smb.Views.Apps.fixContentWidth();
        Smb.Views.Apps.fixMarketplaceContentHeight();
    },

    fixContentWidth: function() {
        // if used for wizard
        if ($('wizard-box-apps')) {
            var innerContainer = $('wizard-box-apps');
            var outerContainer = $('objects-content-area');
        } else {
            var innerContainer = $('category-info');

            if (!$('catalog-actions-box')) {
                return ;
            }

            var outerContainer = $('catalog-actions-box').next();
        }

        if (outerContainer.getHeight() < innerContainer.getHeight()) {
            outerContainer.addClassName('with-scroll');
        } else {
            outerContainer.removeClassName('with-scroll');
        }
    },

    fixMarketplaceContentHeight: function() {
        var marketList = $$('.aps-marketplace-list').first();
        if (marketList) {
            var isOdd = true;
            var oddElement = null;
            var evenElement = null;
            marketList.select('.package-content').each(function(contentElement) {
                if (isOdd) {
                    oddElement = contentElement;
                    isOdd = false;
                } else {
                    evenElement = contentElement;
                    if (oddElement.getHeight() > evenElement.getHeight()) {
                        evenElement.setStyle({ 'height': oddElement.getHeight() + 'px' });
                    } else if (oddElement.getHeight() < evenElement.getHeight()) {
                        oddElement.setStyle({ 'height': evenElement.getHeight() + 'px' });
                    }
                    isOdd = true;
                }
            });
        }
    }
}
