Jsw.namespace('Smb.Views.FileSharing');

Smb.Views.FileSharing = {

    resizeBlocks: function(noTimeOut) {
       if (Smb.Views.FileSharing.resizeBlocksInProgress) {
           return;
       }
       Smb.Views.FileSharing.resizeBlocksInProgress = true;
       if (Smb.Views.FileSharing.resizeBlocksTimeout) {
           window.clearTimeout(Smb.Views.FileSharing.resizeBlocksTimeout);
           Smb.Views.FileSharing.resizeBlocksTimeout = null;
       }
       try {
            var bodyHeight = (Prototype.Browser.IE)
                ? $(document.documentElement).getHeight()
                : $(document.body).getHeight();

            var blockTop = Position.cumulativeOffset($('objects-list'))[1];
            var blockBottom = Element.getHeight($('footer-wrapper'));

            var minBlockHeight = 200;

            var detailsHeight = bodyHeight - blockTop - blockBottom;
            if (detailsHeight < minBlockHeight) {
                detailsHeight = minBlockHeight;
            }

            var listTop =
                Position.cumulativeOffset($('objects-list-content-area'))[1] -
                Position.cumulativeOffset($('objects-list'))[1];

            var contentHeight = detailsHeight - listTop;

            Element.setStyle($('objects-details'), {
                'height': detailsHeight - 3 + 'px'
            });
            Element.setStyle($('objects-list-content-area').up(), {
                'height': contentHeight - 3 + 'px'
            });


            var listHeight = $('objects-list-content-area').down('ul').getHeight();
            var helpHeight = $('objects-list-content-area').down('.hint-help').getHeight();
            var helpDelta = 12; //borders + padding

            var listContentHeight = listHeight + helpHeight + helpDelta;

            var withScroll = listContentHeight > contentHeight;

            Element.setStyle($('objects-list-content-area'), {
                'height': withScroll
                    ? listHeight + helpDelta + 'px'
                    : contentHeight - helpHeight - helpDelta + 'px',
                'padding-bottom': helpHeight + helpDelta + 'px'
            });

            if (!noTimeOut) {
                Smb.Views.FileSharing.resizeBlocksTimeout =
                    Smb.Views.FileSharing.resizeBlocks.delay(0.5, true);
            }
        } catch (e) {
//            alert(e);
        }
        Smb.Views.FileSharing.resizeBlocksInProgress = null;
    },

    showWarning: function(message) {
        $('objects-warnings').show();
        var element = $('objects-warnings').down('.list-actions-msg');
        if (element) {
            element.update('<span>' + message + '</span>').show();
        } else {
            $('objects-warnings')
                .insert('<span class="list-actions-msg"><span>' + message + '</span></span>');
        }
    },

    hideWarning: function() {
        $('objects-warnings').hide();
        var element = $('objects-warnings').down('.list-actions-msg');
        if (element) {
            element.hide();
        }
    },

    clearStatusMessages: function() {
        Smb.Views.FileSharing.hideWarning();
        Jsw.clearStatusMessages();
    }
}

Jsw.onReady(function() {
    Event.observe(
        window,
        'resize',
        function() {
            Smb.Views.FileSharing.resizeBlocks();
        },
        false
    );
    Smb.Views.FileSharing.resizeBlocks();
    Smb.Views.FileSharing.resizeBlocks();
});
