Jsw.namespace('Smb.Views.Wizard');

Smb.Views.Wizard = {

    resizeBlocks: function(noTimeOut) {
       if (Smb.Views.Wizard.resizeBlocksInProgress) {
           return;
       }

       Smb.Views.Wizard.resizeBlocksInProgress = true;

       if (Smb.Views.Wizard.resizeBlocksTimeout) {
           window.clearTimeout(Smb.Views.Wizard.resizeBlocksTimeout);
           Smb.Views.Wizard.resizeBlocksTimeout = null;
       }

       try {
            var bodyHeight = (Prototype.Browser.IE)
                ? $(document.documentElement).getHeight()
                : $(document.body).getHeight();

            var blockTop = Position.cumulativeOffset($('objects-list'))[1];
            var blockBottom = Element.getHeight($('footer-wrapper'));

            var minBlockHeight = 200;

            var detailsHeight = bodyHeight - blockTop - blockBottom;
            if (detailsHeight < minBlockHeight) {
                detailsHeight = minBlockHeight;
            }

            var listTop =
                Position.cumulativeOffset($('objects-list-content-area'))[1] -
                Position.cumulativeOffset($('objects-list'))[1];

            var contentHeight = detailsHeight - listTop;

            Element.setStyle($('objects-details'), {
                'height': detailsHeight - 3 + 'px'
            });
            Element.setStyle($('objects-list-content-area').up(), {
                'height': contentHeight - 3 + 'px'
            });

            var listContentHeight = $('objects-list-content-area').down('ul').getHeight();

            var withScroll = listContentHeight > contentHeight;

            Element.setStyle($('objects-list-content-area'), {
                'height': (withScroll ? listHeight : contentHeight) - 3 + 'px'
            });

            var bottomDelta = Prototype.Browser.IE ? 3 : 1;

            var detailsContentHeight = contentHeight - $('objects-details-footer').getHeight();
            $('objects-content-area').setStyle({ 'height': detailsContentHeight - bottomDelta + 'px' });

            if (Prototype.Browser.IE) {
                // trick to fix layout on Users step under IE6
                $('objects-content-area').setStyle({ 'width': 595 + 'px', 'overflowX': 'hidden' });
            }

            Smb.Views.Apps.fixContentWidth();
            Smb.Views.Apps.fixMarketplaceContentHeight();

            if (!noTimeOut) {
                Smb.Views.Wizard.resizeBlocksTimeout =
                    Smb.Views.Wizard.resizeBlocks.delay(0.5, true);
            }
        } catch (e) {
        }

        Smb.Views.Wizard.resizeBlocksInProgress = null;
    }

}

Jsw.onReady(function() {
    Event.observe(
        window,
        'resize',
        function() {
            Smb.Views.Wizard.resizeBlocks();
        },
        false
    );
    Smb.Views.Wizard.resizeBlocks();
    Smb.Views.Wizard.resizeBlocks();
});
