<?php

$messages = array(
    'title' => 'Upgrading Your Website',
    'docLink' => 'Open the instructions in a new window.',
    'pageHint' => 'Here is an overview of the steps required to place a website copy from development environment into production. Use this information if you have a production version of your website and a new one located elsewhere at the moment, and you want to upgrade your production site with the new version.',
    'pageHint2' => 'The idea is to copy your development site to a staging, check if everything works fine, and then put this version into production. ',

    'step1Title' => '1. Create a staging site.',
    'step1Text' => 'Staging website is a website used to test and review its newer version before it is moved into production. For the best result, a staging site should be in the same subscription where your production site is hosted. If your development copy is in the same subscription, skip this step. Otherwise, create a staging site:',
    'step1Text_powerUser' => 'Staging website is a website used to test and review its newer version before it is moved into production. For the best result, a staging site should be in the same webspace where your production site is hosted. If your development copy is in the same webspace, skip this step. Otherwise, create a staging site:',

    'step1TextStep1' => 'Go to your production subscription.',
    'step1TextStep1_powerUser' => 'Go to your production webspace.',
    'step1TextStep2' => 'Create a domain or subdomain for the new staging site. Do not register a staging domain name if you do not want your staging site being accessible from the Internet.',
    'step1TextStep3' => 'If your development site has an APS application installed, install this application on your staging site.',
    'step1TextStep4' => 'Copy the site files from the development environment to staging:',
    'step1TextStep41' => 'If the development site is hosted on the same server and is accessible from your account, use the "Website Copying" function.',
    'step1TextStep41_powerUser' => 'If the development site is hosted with this Panel instance, use the "Website Copying" function.',
    'step1TextStep42' => 'If the development site is located elsewhere, make sure that your staging site has proper FTP access setup, and use FTP protocol to carry over the site files.',

    'step2Title' => '2. Prepare a database.',
    'step2Text' => 'If you updated the site database during development and are going to use it with your new site, the updated database should be in your production subscription. If it is already there, skip this step. If the updated database is not in the production subscription yet, copy it to a new staging database:',
    'step2Text_powerUser' => 'If you updated the site database and are going to use it with your new site, the updated database should be in your production webspace. If it is already there, skip this step. If the updated database is not in the production webspace yet, copy it to a new staging database:',
    'step2TextStep1' => 'Create a new database in your production subscription.',
    'step2TextStep1_powerUser' => 'Create a new database in your production webspace, it will act as a staging database.',
    'step2TextStep2' => 'Copy the updated database from your development environment to the staging:',
    'step2TextStep21' => 'If your development environment is managed by Panel 10.x, go to the development subscription, then Websites & Domains tab > Databases, click the database name, and then "Make a Copy".',
    'step2TextStep21_powerUser' => 'If your development environment is managed by Panel 10.x, go to the development webspace, then Websites & Domains tab > Databases, click the database name, and then "Make a Copy".',
    'step2TextStep22' => 'If it is managed differently, use the mysqldump utility to create a dump and then to restore it into your staging instance.',

    'step2TextStep3' => 'Update scripts on the staging site to connect to the just created database.',

    'step2Text2' => 'If you are going to use the current production database with your new site:',
    'step2Text2Step1' => 'Turn the maintenance mode on for the production site.',
    'step2Text2Step2' => 'Change the scripts on the production site so that they do not connect to the database any more.',
    'step2Text2Step3' => 'Run database upgrade scripts if needed.',
    'step2Text2Step4' => 'Update scripts on the staging site to connect to the production database.',

    'step3Title' => '3. Adjust APS applications.',
    'step3Text' => 'If your development site has an APS application installed, it is recommended to have the same application pre-installed on your staging site before you start copying files and database (this was mentioned at Step 1). Then deal with the application database:',
    'step3Text1' => 'If you are going to use the new database for production:',
    'step3Text1Step1' => 'Copy the application database from your development environment into staging.',
    'step3Text1Step2' => 'On your staging site, go to the Installed Applications list (at Applications tab), open the application Settings screen and resave the parameters. This will force the scripts that were just copied to reconnect to the staging database.',
    'step3Text2' => 'If you are going to reuse the production database, update the database connection settings for the application on the staging site to connect to the production database.',

    'step4Title' => '4. Verify results.',
    'step4Text' => 'Verify that the staging site works correctly.',

    'step5Title' => '5. Publish the updated site.',
    'step5Text' => 'Change the document root of your production site:',
    'step5TextStep1' => 'In the domain list of your production subscription, click the production site URL.',
    'step5TextStep1_powerUser' => 'In the domain list of your production webspace, click the production site URL.',
    'step5TextStep2' => 'In the "Document root" field, enter the same directory used as a document root by the staging website. Save the site settings.',

    'step6Title' => '6. Make the site available.',
    'step6Text' => 'If your production site was put into maintenance mode, resume normal site operation.',
);
